; 鸞 ஢

.INCLUDE "tn25def.inc"

;****************************************************************************

.def	A = r16
.def	B = r17
.def	zero = r23

;****************************************************************************                     
.DSEG

sreg_int_Watchdog:	.byte	1	;࠭塞 ॣ SREG

;****************************************************************************                     
.CSEG

.org	0
	rjmp	start
.org	INT0addr			;External Interrupt 0
	rjmp	INT_err
.org	PCI0addr			;Pin change Interrupt Request 0
	rjmp	INT_err
.org	OC1Aaddr			;Timer/Counter1 Compare Match 1A
	rjmp	INT_err
.org	OVF1addr			;Timer/Counter1 Overflow
	rjmp	INT_err
.org	OVF0addr			;Timer/Counter0 Overflow
	rjmp	INT_err
.org	ERDYaddr			;EEPROM Ready
	rjmp	INT_err
.org	ACIaddr				;Analog comparator
	rjmp	INT_err
.org	ADCCaddr			;ADC Conversion ready
	rjmp	INT_err
.org	OC1Baddr			;Timer/Counter1 Compare Match B
	rjmp	INT_err
.org	OC0Aaddr			;Timer/Counter0 Compare Match A
	rjmp	INT_err
.org	OC0Baddr			;Timer/Counter0 Compare Match B
	rjmp	INT_err
.org	WDTaddr				;Watchdog Time-out
	rjmp	INT_Watchdog
.org	USI_STARTaddr			;USI START
	rjmp	INT_err
.org	USI_OVFaddr			;USI Overflow
	rjmp	INT_err

;**********************************************	
start:	
	clr	A
	clr	B
	clr	zero

;**********************************************
;⥪
	ldi	A,low(RAMEND)
	out	SPL,A
;	ldi	A,high(RAMEND)		;ATtiny45/85
;	out	SPH,A
	
;**********************************************
;䨣㥬  B
	ldi	A,0b00100111
	out	DDRB,A
	ldi	A,0b00000000
	out	PORTB,A	

;****************************************************
	ldi	A,0b00011000
	out	DIDR0,A			;⪫砥 ஢   室  

;****************************************************
;樠
       	sei				;ࠧ蠥 뢠

;----------------------------------------------------
; ஦ ⠩
	wdr				; ஦ ⠩
	clr	A
	sbr	A,(1<<WDCE)
	out	WDTCR,A
	clr	A
	sbr	A,(1<<WDIE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0)	;2
	out	WDTCR,A

;----------------------------------------------------
;⪫砥 2 ⠩  USI
	in	A,PRR
	sbr	A,(1<<PRTIM1)|(1<<PRTIM0)|(1<<PRUSI)
	out	PRR,A

;----------------------------------------------------
;⪫砥 
	in	A,ACSR
	sbr	A,(1<<ACD)		;⪫. 
	out	ACSR,A

;****************************************************
;뢠 砫 ⠢  稢 PB0  
	cbi	DDRB,0			;ॢ   
	sbi	PORTB,0			; १
	rcall	delay_50
	sbic	PINB,0			;室  ०  ⠢?
	rjmp	ext_zap_eep
	rcall	delay_5
	rcall	ADC_conf		;塞   ADC2
	mov	B,A			;  
	ldi	A,2			; 
	rcall	ESPPZU_write

	sbi	PORTB,1			;࣭ ᢥ⮤
	rcall	delay_50
	rcall	delay_50
	cbi	PORTB,1	

	rcall	ADC_conf_dif		;宫⮥ ८ࠧ
	rcall	delay_5
	rcall	ADC_conf_dif		;塞   ADC3-ADC2
	mov	B,A			;  
	ldi	A,3			; 
	rcall	ESPPZU_write

	sbi	PORTB,2			;࣭ ᢥ⮤
	rcall	delay_50
	rcall	delay_50
	cbi	PORTB,2	

ext_zap_eep:
	sbis	PINB,0			;஢塞 ࠭  ⪠  PB0
	rjmp	PC-1
	sbi	DDRB,0			;ॢ   室
	cbi	PORTB,0			;0

;****************************************************
;**************** MAIN ******************************
;****************************************************
main:	in	A,MCUCR
	sbr	A,(1<<SE)|(1<<SM1)	;Power-down
	out	MCUCR,A
	sleep				;ॢ ஫  ० ᭠
	rjmp	main

;****************************************************
;******* ७   **********************
;****************************************************
izmerenie:
	rcall	ADC_conf		; ADC3
	out	ADCSRA,zero		;⠭ 

;뢠 砫 ⠢  
	push	A
	ldi	A,2			;
	rcall	ESPPZU_read		;  
	pop	A

	cp	A,B			;ࠢ ⠢  ७ 祭
	brcc	vikl
	rjmp	vkl

vkl:	sbi	PORTB,1			; ᢥ⮤  ६ ஢ 㪮 ᨣ
	rcall	generator		;뤠 㪮 ᨣ
	cbi	PORTB,1
	rjmp	next_kanal
	
vikl:	cbi	PORTB,1	
	rjmp	next_kanal

next_kanal:
	rcall	ADC_conf_dif		;宫⮥ ८ࠧ
	rcall	delay_5
	rcall	ADC_conf_dif		;.  ADC3-ADC2
	out	ADCSRA,zero		;⠭ 

;뢠 砫 ⠢  
	push	A
	ldi	A,3			;
	rcall	ESPPZU_read		;  
	pop	A

	cp	A,B			;ࠢ ⠢  ७ 祭
	brcc	vikl2
	rjmp	vkl2

vkl2:	sbi	PORTB,2			; ᢥ⮤  ६ ஢ 㪮 ᨣ
	rcall	generator     		;뤠 㪮 ᨣ
	cbi	PORTB,2
	rjmp	next_kanal2
	
vikl2:	cbi	PORTB,2	
	rjmp	next_kanal2

next_kanal2:
	ret

;*********************************************************************
generator:				;뤠 㪮 ᨣ  쥧⥫
	ldi	B,255			;⥫쭮 㪮 ᨣ
gener:	sbi	PORTB,0
	rcall	delay_5
	cbi	PORTB,0
	rcall	delay_5
	dec	B
	cpi	B,0
	brne	gener
	ret


;**********************************************************************
;******* 樠    ***********************************
;**********************************************************************
ADC_conf:
	ldi	A,0b10000011		; - 1.1V, 2  ADC3
	out	ADMUX,A

	ldi	A,0b11000001		;襭 - ,  , 筮 ८.,  INT, 64.
					;001 - 2
					;010 - 4
					;011 - 8
					;100 - 16
					;101 - 32
					;110 - 64
					;111 - 128
	out	ADCSRA,A

	sbic	ADCSRA,ADSC		;஢塞 祭  ८ࠧ
	rjmp	PC-1			;᫨ ,  塞 ஢

	in	A,ADCL
	in	B,ADCH

	clc
	ror	B
	ror	A
	clc
	ror	B
	ror	A

	out	ADCSRA,zero

	ret

;**********************************************************************
;******* 樠    ***********************************
;**********************************************************************
ADC_conf_dif:
	ldi	A,0b10000110		; - 1.1V,  ADC3-ADC2
	out	ADMUX,A

	ldi	A,0b11000001		;襭 - ,  , 筮 ८.,  INT, 64.
					;001 - 2
					;010 - 4
					;011 - 8
					;100 - 16
					;101 - 32
					;110 - 64
					;111 - 128
	out	ADCSRA,A
	sbic	ADCSRA,ADSC		;஢塞 祭  ८ࠧ
	rjmp	PC-1			;᫨ ,  塞 ஢

	in	A,ADCL
	in	B,ADCH

	clc
	ror	B
	ror	A
	clc
	ror	B
	ror	A

	ret

;*********************************************************************
delay_50:
	ldi	A,50
	dec	A
	cpi	A,0
	brne	PC-2
	ret

;*********************************************************************
delay_10:
	ldi	A,10
	dec	A
	cpi	A,0
	brne	PC-2
	ret

;*********************************************************************
delay_5:
	ldi	A,5
	dec	A
	cpi	A,0
	brne	PC-2
	ret

;*********************************************************************

INT_err:

	reti

;**************************************************************
;*******     *************************************
;**************************************************************
ESPPZU_read:
;⥭  
; 室:  - 
; 室:  - 

	sbic	EECR,EEPE		; 襭?
	rjmp	PC-1
	ldi	B,0
	out	EEARH,B			; .
	out	EEARL,A			; .
	sbi	EECR,EERE		;蠥 ⥭
	in	B,EEDR			;

	ret

ESPPZU_write:
; 室:  - ,  - 
;  
	sbic	EECR,EEPE		; 襭?
	rjmp	PC-1
	cli
	cbi	EECR,EEPM1|EEPM0	;  
	push	A
	ldi	A,0
	out	EEARH,A			; .
	pop	A
	out	EEARL,A			; .
	out	EEDR,B			;

	sbi	EECR,EEMPE		;蠥 
	sbi	EECR,EEPE		;뢠
	sei
	ret

;**************************************************************
;*******   "  " *****************************
;**************************************************************

;**************************************************************
;******** ࠡ⪠ 뢠 INT_Watchdog *******************
;**************************************************************
INT_Watchdog:
	push	A
	push	B
	in	A,sreg			;࠭塞 ॣ ﭨ
	sts	sreg_int_Watchdog,A

	wdr				; 

; ஦ ⠩
	clr	A
	sbr	A,(1<<WDCE)
	out	WDTCR,A
	clr	A
	sbr	A,(1<<WDIE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0)	;2
	out	WDTCR,A

	rcall	izmerenie		;  ७  樨

	lds	A,sreg_int_Watchdog
	out	sreg,A			;⠭ ॣ ﭨ
	pop	B
	pop	A
	reti

;**************************************************************
;******** END *************************************************
;**************************************************************

.exit
